import sexpr
from __future__ import print_function

# This is the only way I can figure out how to make an enum in python
# Or should I just use the class references directly?
# No, I have to turn this into C++ later ... but then, C++ *does* have templates.
class Type:
    pass
Type.List = Type()
Type.Int = Type()
Type.String = Type()
# No Token
Type.Type = Type()
Type.Function = Type()

variables = {}

class Function:
    """ A function object

    (let hello (function
            (args world)
            (body (print "Hello, " world)
            )
        )
    )
    (hello "World!")
    """
    def __init__(self, return_type = None):
        self.return_type = return_type
    # Implemented in subclasses
#    def call(self, args):
#        "args: a python list"
#        pass
    def expect(expr):
        pass

class PrintFunction(Function):
    def call(self, args):
        print(AddFunction.call(None, args))
class AddFunction(Function):
    """ Return an integer or string depending on the types of the arguments
    """
    def call(self, args):
        out = 0
        for arg in args:
            if not (isinstance(arg, int) or isinstance(arg, long)):
                out = ''
                break
        for arg in args:
            out += arg
        return out
        
variables['print'] = PrintFunction()
variables['add'] = AddFunction()
